package providerapi.com.unitech.utility;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v4.app.DialogFragment;
import android.util.Size;
import android.view.WindowManager;
import android.widget.ImageView;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.EncodeHintType;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.qrcode.QRCodeWriter;
import com.google.zxing.qrcode.decoder.ErrorCorrectionLevel;

import java.util.Hashtable;

public class MyDialogFragment extends DialogFragment {

    @NonNull
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        BitMatrix bitmatrix = null;
        Size QRCodeSize = new Size(300, 300);
        Bitmap bitmap = Bitmap.createBitmap(QRCodeSize.getWidth(), QRCodeSize.getHeight(), Bitmap.Config.ARGB_8888);
        //------------------------------------------------------------------------------------------
        //Create QRcode matrix
        try {
            Hashtable <EncodeHintType, Object> hints = new Hashtable <>();
            hints.put(EncodeHintType.ERROR_CORRECTION, ErrorCorrectionLevel.H);
            hints.put(EncodeHintType.CHARACTER_SET, "UTF-8");
            bitmatrix = new QRCodeWriter().encode("//.P" + getTag(), BarcodeFormat.QR_CODE, QRCodeSize.getWidth(), QRCodeSize.getHeight(), hints);
        } catch (Exception e) {
            e.printStackTrace();
        }
        //Create Bitmap
        assert bitmatrix != null;
        for (int y = 0; y < QRCodeSize.getHeight(); y++) {
            for (int x = 0; x < QRCodeSize.getWidth(); x++) {
                bitmap.setPixel(x, y, bitmatrix.get(x, y) ? Color.BLACK : Color.WHITE);
            }
        }
        ImageView imageView = new ImageView(getActivity());
        imageView.setImageBitmap(bitmap);
        //------------------------------------------------------------------------------------------
        return new AlertDialog.Builder(getActivity())
                .setView(imageView)
                .setPositiveButton("Confirm", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int id) {
                        WindowManager.LayoutParams params = getActivity().getWindow().getAttributes();
                        params.screenBrightness = 0.75f;
                        getActivity().getWindow().setAttributes(params);
                    }
                })
                .create();
        //------------------------------------------------------------------------------------------
    }
}